# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/12_call.ipynb.

# %% auto 0
__all__ = ['isattrcall', 'iscallattr']

# %% ../nbs/12_call.ipynb 4
from typing import TypeGuard, Callable
from typing import Any, Type, Callable, TypeGuard, TypeVar, ParamSpec

# %% ../nbs/12_call.ipynb 5
from .core import iscall
from .tgrd import GuardFunc

# %% ../nbs/12_call.ipynb 7
def isattrcall(attr: str) -> GuardFunc:
    '''Checks if the attribute of the object is a callable'''
    def decorator(obj) -> GuardFunc:
        return iscall(getattr(obj, attr, None))
    return decorator

def iscallattr(obj, attr: str) -> TypeGuard[Callable]:
    '''Checks if `obj.attr` is a callable'''
    return isattrcall(attr)(obj)
